<template>
  <q-card flat class="rounded-borders-10 q-mx-auto">
    <q-card-section>
      <div class="row">
        <div class="col-6">
          <span class="title-xsmall text-grey-7"> UPDATE PASSWORD</span>
        </div>
      </div>
    </q-card-section>

    <q-form @submit="validateSubmission(form)">
      <q-card-section>
        <div class="row">
          <div class="col">
            <div class="col-12 q-mb-sm">
              <q-input
                v-model="form.password"
                dense
                outlined
                color="light-blue-10"
                :type="isFieldPassword ? 'password' : 'text'"
                class="q-mt-sm"
                placeholder="New password"
                :rules="[validations.requiredField]"
              >
                <template v-slot:append>
                  <q-icon
                    :name="
                      isFieldPassword
                        ? 'eva-eye-off-outline'
                        : 'eva-eye-outline'
                    "
                    @click="isFieldPassword = !isFieldPassword"
                  />
                </template>
              </q-input>
            </div>

            <div class="col-12 q-mb-sm">
              <q-input
                v-model="form.confirmation_password"
                dense
                outlined
                color="light-blue-10"
                :type="isFieldConfirmPassword ? 'password' : 'text'"
                class="q-mt-sm"
                placeholder="Confirm new password"
                :rules="[validations.requiredField]"
              >
                <template v-slot:append>
                  <q-icon
                    :name="
                      isFieldConfirmPassword
                        ? 'eva-eye-off-outline'
                        : 'eva-eye-outline'
                    "
                    @click="isFieldConfirmPassword = !isFieldConfirmPassword"
                  />
                </template>
              </q-input>
            </div>
          </div>
        </div>
      </q-card-section>

      <p class="text-negative text-center">
        {{ errorMessage }}
      </p>

      <div class="q-mt-lg" align="right">
        <q-btn
          unelevated
          label="SAVE"
          type="submit"
          :class="
            USER_ROLE === 'job-seeker'
              ? 'btn--shade-2 btn-lg text-white'
              : 'bg-positive btn-lg text-white'
          "
          :loading="loading"
        />
      </div>
    </q-form>
  </q-card>
</template>

<script>
import { LocalStorage } from "quasar";
import { defineComponent, ref, reactive } from "vue";
import { requiredField } from "src/hooks/validations";
import { EmployerUserApi, JobseekerUserApi } from "src/hooks/api";
import useNotification from "src/hooks/notification";

export default defineComponent({
  setup() {
    const loading = ref(false);
    const { showNotif } = useNotification();
    const isFieldPassword = ref(true);
    const isFieldConfirmPassword = ref(true);
    const isError = ref(false);
    const errorMessage = ref("");
    const USER_ID = ref(LocalStorage.getItem("auth").id);
    const USER_ROLE = ref(LocalStorage.getItem("auth").user_type);

    const form = reactive({
      password: "",
      confirmation_password: "",
    });

    const validateSubmission = (form) => {
      if (form.password !== form.confirmation_password) {
        isError.value = true;
        errorMessage.value = "PASSWORDS MUST MATCH.";
      } else {
        updatePassword(form);
      }
    };

    const updatePassword = async (payload) => {
      loading.value = true;

      let API_FUNCTION =
        USER_ROLE.value === "job-seeker" ? JobseekerUserApi : EmployerUserApi;

      await API_FUNCTION.updatePassword(USER_ID.value, payload)
        .then((response) => {
          showNotif({
            message: response.data.message,
            color: "positive",
            position: "bottom-right",
          });
        })
        .catch((error) => {
          isError.value = true;
          errorMessage.value = error?.response?.data?.message.toUpperCase();
        })
        .finally(() => {
          loading.value = false;
        });
    };

    return {
      form,
      isFieldPassword,
      isFieldConfirmPassword,
      isError,
      errorMessage,
      loading,
      USER_ID,
      USER_ROLE,
      validations: {
        requiredField,
      },
      validateSubmission,
    };
  },
});
</script>

<style lang="scss" scoped>
.q-card {
  width: 340px !important;
  padding: 20px;

  &__section {
    padding: 0 !important;
  }
}
</style>
